import { AST_NODE_TYPES, TSESLint, TSESTree } from '@typescript-eslint/utils';
export declare const ASTUtils: {
    isNodeOfOneOf<T extends AST_NODE_TYPES>(node: TSESTree.Node, types: ReadonlyArray<T>): node is TSESTree.Node & {
        type: T;
    };
    isIdentifier(node: TSESTree.Node): node is TSESTree.Identifier;
    isIdentifierWithName(node: TSESTree.Node, name: string): node is TSESTree.Identifier;
    isIdentifierWithOneOfNames<T extends Array<string>>(node: TSESTree.Node, name: T): node is TSESTree.Identifier & {
        name: T[number];
    };
    isProperty(node: TSESTree.Node): node is TSESTree.Property;
    isObjectExpression(node: TSESTree.Node): node is TSESTree.ObjectExpression;
    isPropertyWithIdentifierKey(node: TSESTree.Node, key: string): node is TSESTree.Property;
    findPropertyWithIdentifierKey(properties: Array<TSESTree.ObjectLiteralElement>, key: string): TSESTree.Property | undefined;
    getNestedIdentifiers(node: TSESTree.Node): Array<TSESTree.Identifier>;
    isAncestorIsCallee(identifier: TSESTree.Node): boolean;
    traverseUpOnly(identifier: TSESTree.Node, allowedNodeTypes: Array<AST_NODE_TYPES>): TSESTree.Node;
    isDeclaredInNode(params: {
        functionNode: TSESTree.Node;
        reference: TSESLint.Scope.Reference;
        scopeManager: TSESLint.Scope.ScopeManager;
    }): boolean;
    getExternalRefs(params: {
        scopeManager: TSESLint.Scope.ScopeManager;
        sourceCode: Readonly<TSESLint.SourceCode>;
        node: TSESTree.Node;
    }): Array<TSESLint.Scope.Reference>;
    mapKeyNodeToText(node: TSESTree.Node, sourceCode: Readonly<TSESLint.SourceCode>): string;
    mapKeyNodeToBaseText(node: TSESTree.Node, sourceCode: Readonly<TSESLint.SourceCode>): string;
    isValidReactComponentOrHookName(identifier: TSESTree.Identifier | null | undefined): boolean;
    getFunctionAncestor(sourceCode: Readonly<TSESLint.SourceCode>, node: TSESTree.Node): TSESTree.ArrowFunctionExpression | TSESTree.FunctionDeclarationWithOptionalName | TSESTree.FunctionExpression | undefined;
    getReferencedExpressionByIdentifier(params: {
        node: TSESTree.Node;
        context: Readonly<TSESLint.RuleContext<string, ReadonlyArray<unknown>>>;
    }): TSESTree.Expression | null;
    getClosestVariableDeclarator(node: TSESTree.Node): TSESTree.VariableDeclaratorDefiniteAssignment | TSESTree.VariableDeclaratorMaybeInit | undefined;
    getNestedReturnStatements(node: TSESTree.Node): Array<TSESTree.ReturnStatement>;
};
